_G.cgrade = _G.cgrade or {}

cgrade.settings = {
	grade = 8,
	ingEnabled = true,
}

cgrade.grades = {
	"color_payday",
	"color_heat",
	"color_nice",
	"color_sin",
	"color_bhd",
	"color_xgen",
	"color_xxxgen",
	"color_matrix"
}

function cgrade:Load()
	local file = io.open(SavePath .. "cgrade_option.txt", "r")
	if file then
		for k, v in pairs(json.decode(file:read("*all")) or {}) do
			if k then
				cgrade.settings[k] = v
			end
		end
		
		file:close()
	end
end

function cgrade:Save()
	local file = io.open(SavePath .. "cgrade_option.txt", "w+")
	if file then
		file:write(json.encode(cgrade.settings))
		file:close()
	end
end


function cgrade:GetGrade()
	return cgrade.grades[cgrade.settings.grade]
end

if MenuSceneManager then
	cgrade:Load()
	Hooks:PostHook(MenuSceneManager, "_set_up_environments", "ApplyMenuGrade", function(self)
        local grade = cgrade:GetGrade()
		for env, data in pairs(self._environments) do
            if data.color_grading then
                data.color_grading = grade
            end
        end
    end)
end

if IngameAccessCamera then
    Hooks:PostHook(IngameAccessCamera, "at_enter", "ApplyInGameGrade", function(self)
		if Utils:IsInGameState() and cgrade.settings.ingEnabled == false then
			managers.environment_controller:set_default_color_grading("color_payday")
		else 
			managers.environment_controller:set_default_color_grading(cgrade:GetGrade())
		end
		managers.environment_controller:refresh_render_settings()
    end)
end

if TweakData then
	for _, level in pairs(tweak_data.levels._level_index) do
		if Utils:IsInGameState() and cgrade.settings.ingEnabled == false then
			local grade = "color_payday"
		else 
			local grade = cgrade:GetGrade()
		end
		if grade and tweak_data.levels[level] ~= nil then
			tweak_data.levels[level].env_params = tweak_data.levels[level].env_params or {}
			tweak_data.levels[level].env_params.color_grading = (grade)
		end
	end
end

if Global.level_data and Global.level_data.level_id then
    local level_id = Global.level_data.level_id
    if tweak_data.levels[level_id] ~= nil then
        local colour_grading_val = cgrade:GetGrade()
		tweak_data.levels[level_id].env_params = tweak_data.levels[level_id].env_params or {}
        tweak_data.levels[level_id].env_params.color_grading = colour_grading_val
    end
end

Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_cgrade", function(menu_manager)
	
	MenuCallbackHandler.cgrade_gradeselec_callb = function(this, item)
		cgrade.settings.grade = tonumber(item:value())
		if Utils:IsInGameState() and cgrade.settings.ingEnabled == false then
			managers.environment_controller:set_default_color_grading("color_payday")
			managers.environment_controller:refresh_render_settings()
		else 
			managers.environment_controller:set_default_color_grading(cgrade:GetGrade())
			managers.environment_controller:refresh_render_settings()
		end
		cgrade:Save()
	end
	
	MenuCallbackHandler.cgrade_ingtgle_callb = function(this, item)
		cgrade.settings.ingEnabled = Utils:ToggleItemToBoolean(item)
		if cgrade.settings.ingEnabled == false then
			managers.environment_controller:set_default_color_grading("color_payday")
		else
			managers.environment_controller:set_default_color_grading(cgrade:GetGrade())
		end
		managers.environment_controller:refresh_render_settings()
	end
	
end)

LocalizationManager:load_localization_file(ModPath .. "loc/eng.json")
MenuHelper:LoadFromJsonFile(ModPath .. "menu/options.json", cgrade, cgrade.settings)